﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xuni.CollectionView;

namespace CollectionViewOnDemand
{
    public static class ListViewEx
    {
        private static int PageSize { get; set; }
        public static void SetPageSize(this ListView listView, int pageSize)
        {
            PageSize = pageSize;
        }
        public static void LoadItemsOnDemand<T>(this ListView listview, XuniCursorCollectionView<T> collectionView)
        {
            listview.ItemAppearing += (s, e) =>
            {
                var index = collectionView.IndexOf((T)e.Item);
                if (index == collectionView.Count - 1)
                {
                    if (collectionView.HasMoreItems)
                    {
                        collectionView.LoadMoreItemsAsync(PageSize);
                    }
                }
            };
            if(collectionView.HasMoreItems)
            {
                collectionView.LoadMoreItemsAsync(PageSize);
            }
        }
    }
}
